---
- name: "Dotenv"
  include_role:
    name: "sutty_dotenv"
  when: "dotenv_required | default(true)"
- when: "restic_required | default(true)"
  block:
  - name: "Dump databases"
    include_role:
      name: "sutty_mysql_dump"
    when: "mysql_user is defined"
  - when: "postgresql_database is defined"
    block:
    - name: "Remove previous backup"
      file:
        state: "absent"
        path: "{{ postgresql_dump }}"
    - name: "Dump databases"
      postgresql_db:
        state: "dump"
        name: "{{ postgresql_database }}"
        target: "{{ postgresql_dump }}"
        login_user: "{{ postgresql_username | default(omit) }}"
        login_password: "{{ postgresql_password | default(omit) }}"
        login_unix_socket: "{{ postgresql_unix_socket | default(omit) }}"
        login_host: "{{ postgresql_host | default(omit) }}"
  - name: "Env"
    include_role:
      name: "sutty_dotenv_create"
  - name: "Backup"
    include_role:
      name: "sutty_restic"
  always:
  - name: "Env"
    include_role:
      name: "sutty_dotenv_remove"
    when: "dotenv_required | default(true)"
- when: "borg_required | default(false)"
  block:
  - name: "Borg"
    include_role:
      name: "sutty_container"
    vars:
      name: "borg"
      version: "3.18.0"
      restart_policy: "no"
      detach: false
      cleanup: true
      command: "backup"
      dns_servers:
      - "8.8.8.8"
      - "8.8.4.4"
      published_ports: []
      volumes:
      - "{{ ansible_env.SSH_AUTH_SOCK }}:/agent"
      - "{{ data }}:/srv/data"
      env:
        BORG_PASSPHRASE: "{{ borg_passphrase }}"
        KEEP: "{{ borg_keep }}"
        DEST: "{{ borg_destination }}"
        SSH_ALIAS: "{{ borg_ssh_alias }}"
        SSH_SERVER: "{{ borg_ssh_server }}"
        SSH_USER: "{{ borg_ssh_user }}"
        SSH_PORT: "{{ borg_ssh_port }}"
        SSH_KNOWN_HOSTS: "{{ borg_ssh_known_hosts }}"
        SSH_AUTH_SOCK: "/agent"
- when: "restic_container_required | default(false)"
  block:
  - name: "Restic container"
    include_role:
      name: "sutty_container"
    vars:
      name: "restic"
      version: "3.18.0"
      restart_policy: "no"
      detach: false
      cleanup: true
      command: "{{ item.command }}"
      dns_servers:
      - "8.8.8.8"
      - "8.8.4.4"
      published_ports: []
      volumes:
      - "{{ data }}:/srv/data"
      env:
        RESTIC_PASSWORD: "{{ restic_password }}"
        B2_ACCOUNT_ID: "{{ b2_account_id | default(omit) }}"
        B2_ACCOUNT_KEY: "{{ b2_account_key | default(omit) }}"
        AWS_ACCESS_KEY_ID: "{{ aws_access_key_id | default(omit) }}"
        AWS_SECRET_ACCESS_KEY: "{{ aws_secret_access_key | default(omit) }}"
        GOMAXPROCS: "1"
        GO_MAX_PROCS: "1"
        RESTIC_READ_CONCURRENCY: "1"
        RESTIC_REPOSITORY: "{{ restic_repository }}"
    with_items:
    - command: "restic cat config || restic init"
    - command: "nice -n 19 restic backup --no-scan /srv/data/"
